Package org.codehaus.groovy.runtime.metaclass

## Class ConcurrentReaderHashMap

- java.lang.Object
- - java.util.AbstractMap
  - - org.codehaus.groovy.runtime.metaclass.ConcurrentReaderHashMap

- All Implemented Interfaces:
    `Serializable`, `Cloneable`, `Map`

      public class ConcurrentReaderHashMap
      extends AbstractMap
      implements Cloneable, Serializable

  A hash table that supports mostly-concurrent reading, but exclusive writing. Because reads are not limited to periods without writes, a concurrent reader policy is weaker than a classic reader/writer policy, but is generally faster and allows more concurrency. This class is a good choice especially for tables that are mainly created by one thread during the start-up phase of a program, and from then on, are mainly read (with perhaps occasional additions or removals) in many threads. If you also need concurrency among writes, consider instead using ConcurrentHashMap.

  Successful retrievals using get(key) and containsKey(key) usually run without locking. Unsuccessful ones (i.e., when the key is not present) do involve brief synchronization (locking). Also, the size and isEmpty methods are always synchronized.

  Because retrieval operations can ordinarily overlap with writing operations (i.e., put, remove, and their derivatives), retrievals can only be guaranteed to return the results of the most recently completed operations holding upon their onset. Retrieval operations may or may not return results reflecting in-progress writing operations. However, the retrieval operations do always return consistent results -- either those holding before any single modification or after it, but never a nonsense result. For aggregate operations such as putAll and clear, concurrent reads may reflect insertion or removal of only some entries. In those rare contexts in which you use a hash table to synchronize operations across threads (for example, to prevent reads until after clears), you should either encase operations in synchronized blocks, or instead use java.util.Hashtable.

  This class also supports optional guaranteed exclusive reads, simply by surrounding a call within a synchronized block, as in
  `ConcurrentReaderHashMap t; ... Object v;
  synchronized(t) { v = t.get(k); }`
  But this is not usually necessary in practice. For example, it is generally inefficient to write:

         ConcurrentReaderHashMap t; ...            // Inefficient version
         Object key; ...
         Object value; ...
         synchronized(t) {
           if (!t.containsKey(key))
             t.put(key, value);
             // other code if not previously present
           }
           else {
             // other code if it was previously present
           }
         }

  Instead, if the values are intended to be the same in each case, just take advantage of the fact that put returns null if the key was not previously present:

         ConcurrentReaderHashMap t; ...                // Use this instead
         Object key; ...
         Object value; ...
         Object oldValue = t.put(key, value);
         if (oldValue == null) {
           // other code if not previously present
         }
         else {
           // other code if it was previously present
         }

  Iterators and Enumerations (i.e., those returned by keySet().iterator(), entrySet().iterator(), values().iterator(), keys(), and elements()) return elements reflecting the state of the hash table at some point at or since the creation of the iterator/enumeration. They will return at most one instance of each element (via next()/nextElement()), but might or might not reflect puts and removes that have been processed since they were created. They do not throw ConcurrentModificationException. However, these iterators are designed to be used by only one thread at a time. Sharing an iterator across multiple threads may lead to unpredictable results if the table is being concurrently modified. Again, you can ensure interference-free iteration by enclosing the iteration in a synchronized block.

  This class may be used as a direct replacement for any use of java.util.Hashtable that does not depend on readers being blocked during updates. Like Hashtable but unlike java.util.HashMap, this class does NOT allow `null` to be used as a key or value. This class is also typically faster than ConcurrentHashMap when there is usually only one thread updating the table, but possibly many retrieving values from it.

  Implementation note: A slightly faster implementation of this class will be possible once planned Java Memory Model revisions are in place.

  [ Introduction to this package. ]

  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `protected static class` | `ConcurrentReaderHashMap.BarrierLock` | A Serializable class for barrier lock
    `protected static class` | `ConcurrentReaderHashMap.Entry` | ConcurrentReaderHashMap collision list entry.
    `protected class` | `ConcurrentReaderHashMap.HashIterator` |
    `protected class` | `ConcurrentReaderHashMap.KeyIterator` |
    `protected class` | `ConcurrentReaderHashMap.ValueIterator` |

    - ### Nested classes/interfaces inherited from class java.util.AbstractMap

      `AbstractMap.SimpleEntry<K extends Object,​V extends Object>, AbstractMap.SimpleImmutableEntry<K extends Object,​V extends Object>`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected ConcurrentReaderHashMap.BarrierLock` | `barrierLock` | Lock used only for its memory effects.
    `protected int` | `count` | The total number of mappings in the hash table.
    `static int` | `DEFAULT_INITIAL_CAPACITY` | The default initial number of table slots for this table (32).
    `static float` | `DEFAULT_LOAD_FACTOR` | The default load factor for this table (1.0).
    `protected Set` | `entrySet` |
    `protected Set` | `keySet` |
    `protected Object` | `lastWrite` | field written to only to guarantee lock ordering.
    `protected float` | `loadFactor` | The load factor for the hash table.
    `protected ConcurrentReaderHashMap.Entry[]` | `table` | The hash table data.
    `protected int` | `threshold` | The table is rehashed when its size exceeds this threshold.
    `protected Collection` | `values` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ConcurrentReaderHashMap()` | Constructs a new, empty map with a default initial capacity and load factor.
    `ConcurrentReaderHashMap​(int initialCapacity)` | Constructs a new, empty map with the specified initial capacity and default load factor.
    `ConcurrentReaderHashMap​(int initialCapacity, float loadFactor)` | Constructs a new, empty map with the specified initial capacity and the specified load factor.
    `ConcurrentReaderHashMap​(Map t)` | Constructs a new map with the same mappings as the given map.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `int` | `capacity()` |
    `void` | `clear()` | Removes all mappings from this map.
    `Object` | `clone()` | Returns a shallow copy of this `ConcurrentReaderHashMap` instance: the keys and values themselves are not cloned.
    `boolean` | `contains​(Object value)` | Tests if some key maps into the specified value in this table.
    `boolean` | `containsKey​(Object key)` | Tests if the specified object is a key in this table.
    `boolean` | `containsValue​(Object value)` | Returns `true` if this map maps one or more keys to the specified value.
    `Enumeration` | `elements()` | Returns an enumeration of the values in this table.
    `Set` | `entrySet()` | Returns a collection view of the mappings contained in this map.
    `protected boolean` | `eq​(Object x, Object y)` | Check for equality of non-null references x and y.
    `protected boolean` | `findAndRemoveEntry​(Map.Entry entry)` | Helper method for entrySet.remove
    `Object` | `get​(Object key)` | Returns the value to which the specified key is mapped in this table.
    `protected ConcurrentReaderHashMap.Entry[]` | `getTableForReading()` | Get ref to table; the reference and the cells it accesses will be at least as fresh as from last use of barrierLock
    `boolean` | `isEmpty()` | Returns `true` if this map contains no key-value mappings.
    `Enumeration` | `keys()` | Returns an enumeration of the keys in this table.
    `Set` | `keySet()` | Returns a set view of the keys contained in this map.
    `float` | `loadFactor()` |
    `Object` | `put​(Object key, Object value)` | Maps the specified `key` to the specified `value` in this table.
    `void` | `putAll​(Map t)` | Copies all of the mappings from the specified map to this one.
    `protected void` | `recordModification​(Object x)` | Force a memory synchronization that will cause all readers to see table.
    `protected void` | `rehash()` | Rehashes the contents of this map into a new table with a larger capacity.
    `Object` | `remove​(Object key)` | Removes the key (and its corresponding value) from this table.
    `int` | `size()` | Returns the number of key-value mappings in this map.
    `protected Object` | `sput​(Object key, Object value, int hash)` | Continuation of put(), called only when sync lock is held and interference has been detected.
    `protected Object` | `sremove​(Object key, int hash)` | Continuation of remove(), called only when sync lock is held and interference has been detected.
    `Collection` | `values()` | Returns a collection view of the values contained in this map.

    - ### Methods inherited from class java.util.AbstractMap

      `equals, hashCode, toString`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Map

      `compute, computeIfAbsent, computeIfPresent, forEach, getOrDefault, merge, putIfAbsent, remove, replace, replace, replaceAll`

- - ### Field Detail

    - #### barrierLock

          protected final ConcurrentReaderHashMap.BarrierLock barrierLock

      Lock used only for its memory effects.

    - #### lastWrite

          protected transient Object lastWrite

      field written to only to guarantee lock ordering.

    - #### DEFAULT_INITIAL_CAPACITY

          public static final int DEFAULT_INITIAL_CAPACITY

      The default initial number of table slots for this table (32). Used when not otherwise specified in constructor.
      See Also:
        Constant Field Values

    - #### DEFAULT_LOAD_FACTOR

          public static final float DEFAULT_LOAD_FACTOR

      The default load factor for this table (1.0). Used when not otherwise specified in constructor.
      See Also:
        Constant Field Values

    - #### table

          protected transient ConcurrentReaderHashMap.Entry[] table

      The hash table data.

    - #### count

          protected transient int count

      The total number of mappings in the hash table.

    - #### threshold

          protected int threshold

      The table is rehashed when its size exceeds this threshold. (The value of this field is always (int)(capacity * loadFactor).)

    - #### loadFactor

          protected float loadFactor

      The load factor for the hash table.

    - #### keySet

          protected transient Set keySet

    - #### entrySet

          protected transient Set entrySet

    - #### values

          protected transient Collection values

  - ### Constructor Detail

    - #### ConcurrentReaderHashMap

          public ConcurrentReaderHashMap​(int initialCapacity,
                                         float loadFactor)

      Constructs a new, empty map with the specified initial capacity and the specified load factor.
      Parameters:
        `initialCapacity` - the initial capacity The actual initial capacity is rounded to the nearest power of two.
        `loadFactor` - the load factor of the ConcurrentReaderHashMap
      Throws:
        `IllegalArgumentException` - if the initial maximum number of elements is less than zero, or if the load factor is non-positive.

    - #### ConcurrentReaderHashMap

          public ConcurrentReaderHashMap​(int initialCapacity)

      Constructs a new, empty map with the specified initial capacity and default load factor.
      Parameters:
        `initialCapacity` - the initial capacity of the ConcurrentReaderHashMap.
      Throws:
        `IllegalArgumentException` - if the initial maximum number of elements is less than zero.

    - #### ConcurrentReaderHashMap

          public ConcurrentReaderHashMap()

      Constructs a new, empty map with a default initial capacity and load factor.

    - #### ConcurrentReaderHashMap

          public ConcurrentReaderHashMap​(Map t)

      Constructs a new map with the same mappings as the given map. The map is created with a capacity of twice the number of mappings in the given map or 16 (whichever is greater), and a default load factor.

  - ### Method Detail

    - #### recordModification

          protected final void recordModification​(Object x)

      Force a memory synchronization that will cause all readers to see table. Call only when already holding main sync lock.

    - #### getTableForReading

          protected final ConcurrentReaderHashMap.Entry[] getTableForReading()

      Get ref to table; the reference and the cells it accesses will be at least as fresh as from last use of barrierLock

    - #### eq

          protected boolean eq​(Object x,
                               Object y)

      Check for equality of non-null references x and y.

    - #### size

          public int size()

      Returns the number of key-value mappings in this map.
      Specified by:
        `size` in interface `Map`
      Overrides:
        `size` in class `AbstractMap`
      Returns:
        the number of key-value mappings in this map.

    - #### isEmpty

          public boolean isEmpty()

      Returns `true` if this map contains no key-value mappings.
      Specified by:
        `isEmpty` in interface `Map`
      Overrides:
        `isEmpty` in class `AbstractMap`
      Returns:
        `true` if this map contains no key-value mappings.

    - #### get

          public Object get​(Object key)

      Returns the value to which the specified key is mapped in this table.
      Specified by:
        `get` in interface `Map`
      Overrides:
        `get` in class `AbstractMap`
      Parameters:
        `key` - a key in the table.
      Returns:
        the value to which the key is mapped in this table; `null` if the key is not mapped to any value in this table.
      Throws:
        `NullPointerException` - if the key is `null`.
      See Also:
        `put(Object, Object)`

    - #### containsKey

          public boolean containsKey​(Object key)

      Tests if the specified object is a key in this table.
      Specified by:
        `containsKey` in interface `Map`
      Overrides:
        `containsKey` in class `AbstractMap`
      Parameters:
        `key` - possible key.
      Returns:
        `true` if and only if the specified object is a key in this table, as determined by the `equals` method; `false` otherwise.
      Throws:
        `NullPointerException` - if the key is `null`.
      See Also:
        `contains(Object)`

    - #### put

          public Object put​(Object key,
                            Object value)

      Maps the specified `key` to the specified `value` in this table. Neither the key nor the value can be `null`.

      The value can be retrieved by calling the `get` method with a key that is equal to the original key.

      Specified by:
        `put` in interface `Map`
      Overrides:
        `put` in class `AbstractMap`
      Parameters:
        `key` - the table key.
        `value` - the value.
      Returns:
        the previous value of the specified key in this table, or `null` if it did not have one.
      Throws:
        `NullPointerException` - if the key or value is `null`.
      See Also:
        `Object.equals(Object)`, `get(Object)`

    - #### sput

          protected Object sput​(Object key,
                                Object value,
                                int hash)

      Continuation of put(), called only when sync lock is held and interference has been detected.

    - #### rehash

          protected void rehash()

      Rehashes the contents of this map into a new table with a larger capacity. This method is called automatically when the number of keys in this map exceeds its capacity and load factor.

    - #### remove

          public Object remove​(Object key)

      Removes the key (and its corresponding value) from this table. This method does nothing if the key is not in the table.
      Specified by:
        `remove` in interface `Map`
      Overrides:
        `remove` in class `AbstractMap`
      Parameters:
        `key` - the key that needs to be removed.
      Returns:
        the value to which the key had been mapped in this table, or `null` if the key did not have a mapping.
      Throws:
        `NullPointerException` - if the key is `null`.

    - #### sremove

          protected Object sremove​(Object key,
                                   int hash)

      Continuation of remove(), called only when sync lock is held and interference has been detected.

    - #### containsValue

          public boolean containsValue​(Object value)

      Returns `true` if this map maps one or more keys to the specified value. Note: This method requires a full internal traversal of the hash table, and so is much slower than method `containsKey`.
      Specified by:
        `containsValue` in interface `Map`
      Overrides:
        `containsValue` in class `AbstractMap`
      Parameters:
        `value` - value whose presence in this map is to be tested.
      Returns:
        `true` if this map maps one or more keys to the specified value.
      Throws:
        `NullPointerException` - if the value is `null`.

    - #### contains

          public boolean contains​(Object value)

      Tests if some key maps into the specified value in this table. This operation is more expensive than the `containsKey` method.

      Note that this method is identical in functionality to containsValue, (which is part of the Map interface in the collections framework).

      Parameters:
        `value` - a value to search for.
      Returns:
        `true` if and only if some key maps to the `value` argument in this table as determined by the `equals` method; `false` otherwise.
      Throws:
        `NullPointerException` - if the value is `null`.
      See Also:
        `containsKey(Object)`, `containsValue(Object)`, `Map`

    - #### putAll

          public void putAll​(Map t)

      Copies all of the mappings from the specified map to this one. These mappings replace any mappings that this map had for any of the keys currently in the specified Map.
      Specified by:
        `putAll` in interface `Map`
      Overrides:
        `putAll` in class `AbstractMap`
      Parameters:
        `t` - Mappings to be stored in this map.

    - #### clear

          public void clear()

      Removes all mappings from this map.
      Specified by:
        `clear` in interface `Map`
      Overrides:
        `clear` in class `AbstractMap`

    - #### clone

          public Object clone()

      Returns a shallow copy of this `ConcurrentReaderHashMap` instance: the keys and values themselves are not cloned.
      Overrides:
        `clone` in class `AbstractMap`
      Returns:
        a shallow copy of this map.

    - #### keySet

          public Set keySet()

      Returns a set view of the keys contained in this map. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. The set supports element removal, which removes the corresponding mapping from this map, via the `Iterator.remove`, `Set.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.
      Specified by:
        `keySet` in interface `Map`
      Overrides:
        `keySet` in class `AbstractMap`
      Returns:
        a set view of the keys contained in this map.

    - #### values

          public Collection values()

      Returns a collection view of the values contained in this map. The collection is backed by the map, so changes to the map are reflected in the collection, and vice-versa. The collection supports element removal, which removes the corresponding mapping from this map, via the `Iterator.remove`, `Collection.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.
      Specified by:
        `values` in interface `Map`
      Overrides:
        `values` in class `AbstractMap`
      Returns:
        a collection view of the values contained in this map.

    - #### entrySet

          public Set entrySet()

      Returns a collection view of the mappings contained in this map. Each element in the returned collection is a `Map.Entry`. The collection is backed by the map, so changes to the map are reflected in the collection, and vice-versa. The collection supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Collection.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.
      Specified by:
        `entrySet` in interface `Map`
      Specified by:
        `entrySet` in class `AbstractMap`
      Returns:
        a collection view of the mappings contained in this map.

    - #### findAndRemoveEntry

          protected boolean findAndRemoveEntry​(Map.Entry entry)

      Helper method for entrySet.remove

    - #### keys

          public Enumeration keys()

      Returns an enumeration of the keys in this table.
      Returns:
        an enumeration of the keys in this table.
      See Also:
        `Enumeration`, `elements()`, `keySet()`, `Map`

    - #### elements

          public Enumeration elements()

      Returns an enumeration of the values in this table. Use the Enumeration methods on the returned object to fetch the elements sequentially.
      Returns:
        an enumeration of the values in this table.
      See Also:
        `Enumeration`, `keys()`, `values()`, `Map`

    - #### capacity

          public int capacity()

      Returns:
        the number of slots in this table

    - #### loadFactor

          public float loadFactor()

      Returns:
        the load factor